#!/bin/sh

# Generate callbacks 

CLASSES="DiaCanvasItem DIA_TYPE_CANVAS_ITEM dia_canvas_item 
        DiaCanvasGroup DIA_TYPE_CANVAS_GROUP dia_canvas_group
        DiaCanvasElement DIA_TYPE_CANVAS_ELEMENT dia_canvas_element
        DiaCanvasLine DIA_TYPE_CANVAS_LINE dia_canvas_line
        DiaCanvasImage DIA_TYPE_CANVAS_IMAGE dia_canvas_image
        DiaCanvasBox DIA_TYPE_CANVAS_BOX dia_canvas_box
        DiaCanvasText DIA_TYPE_CANVAS_TEXT dia_canvas_text"

cat > diacanvascallbacks.defs <<EOF
;; -*- scheme -*-
; vim:syntax=scheme:sw=2

; Events and callbacks as defined in DiaCanvasItemClass
EOF

cat > diacanvascallbacks.override <<EOF
EOF

echo "$CLASSES" | \
while read CLASS_TYPE TYPE_TYPE METHOD_PREFIX; do
        cat diacanvascallbacks.defs.tmpl | \
                sed -e 's/@Type@/'$CLASS_TYPE'/g' \
                    -e 's/@TYPETYPE@/'$TYPE_TYPE'/g' \
                    -e 's/@type@/'$METHOD_PREFIX'/g' >> diacanvascallbacks.defs

        # Do not generate override code for DiaCanvasItem
        # test "$Type" == "DiaCanvasItem" || \
        cat diacanvascallbacks.override.tmpl | \
                sed -e 's/@Type@/'$CLASS_TYPE'/g' \
                    -e 's/@TYPETYPE@/'$TYPE_TYPE'/g' \
                    -e 's/@type@/'$METHOD_PREFIX'/g' >> diacanvascallbacks.override
done

